//---------------------------------------------------------------------------
#ifndef BrwEditH
#define BrwEditH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <StdCtrls.hpp>
//---------------------------------------------------------------------------

typedef void __fastcall ( __closure *TBeforeBrwEvent )( TObject *Sender );
typedef void __fastcall ( __closure *TAfterBrwEvent  )( TObject *Sender, AnsiString &FileName, bool &Accept );
//---------------------------------------------------------------------------

class PACKAGE TBrowseEdit : public TCustomEdit
{
public :
	__fastcall TBrowseEdit( TComponent *Owner );
    __fastcall ~TBrowseEdit( );

	__property TButton *Button = { read = FButton, nodefault };

protected :
	virtual void    __fastcall  Notification( TComponent *AComponent, TOperation Operation );
	virtual void    __fastcall  ButtonClick( TObject *Sender );
	virtual void    __fastcall  CreateParams( TCreateParams &Params );
	virtual void    __fastcall  CreateWnd( void );

private :
	TButton        *FButton;
    TOpenDialog    *FDialog;
    TBeforeBrwEvent FOnBeforeBrw;
    TAfterBrwEvent  FOnAfterBrw;

    void    __fastcall  SetDialog( TOpenDialog *aDialog );
    void    __fastcall  SetEditorEnabled( bool aEditorEnabled );
	int     __fastcall  GetMinHeight( void );
    void    __fastcall  SetEditRect( void );
	MESSAGE void __fastcall WMSize( TWMSize &Message );
	MESSAGE void __fastcall CMEnter( TWMNoParams &Message );

__published :
	__property AutoSelect ;
	__property AutoSize ;
	__property Color ;
	__property Ctl3D ;
    __property TOpenDialog *Dialog = { read = FDialog, write = SetDialog };
	__property DragCursor ;
	__property DragMode ;
	__property Enabled ;
	__property Font ;
	__property ParentColor ;
	__property ParentCtl3D ;
	__property ParentFont ;
	__property ParentShowHint ;
	__property PopupMenu ;
	__property ReadOnly ;
	__property ShowHint ;
	__property TabOrder ;
	__property TabStop ;
    __property Text ;
	__property Visible ;

    //  new event
    __property TBeforeBrwEvent  OnBeforeBrw = { read = FOnBeforeBrw, write = FOnBeforeBrw };
    __property TAfterBrwEvent   OnAfterBrw  = { read = FOnAfterBrw, write = FOnAfterBrw };

	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;

#pragma warn -inl
BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER( WM_SIZE, TWMSize, WMSize );
    VCL_MESSAGE_HANDLER( CM_ENTER, TWMNoParams, CMEnter );
END_MESSAGE_MAP( TCustomEdit );
#pragma warn .inl
};
//---------------------------------------------------------------------------
#endif
